Unit rss2r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure rss2r(var X :Array of Real; var Y :Array of Real;
                var N :Integer; K :Integer; L :Integer; DT :Real;
                var SX :Array of Real; var SY :Array of Real;
                var SXY1 :Array of Real; var SXY2 :Array of Real;
                var Z1 :Array of Real; var Z2 :Array of Real);

implementation

procedure rss2r(var X :Array of Real; var Y :Array of Real;
                var N :Integer; K :Integer; L :Integer; DT :Real;
                var SX :Array of Real; var SY :Array of Real;
                var SXY1 :Array of Real; var SXY2 :Array of Real;
                var Z1 :Array of Real; var Z2 :Array of Real);
var
I,IS_,IJL,J,JL,NC :Integer;
A,A1,A2,B,B1,B2,C,D,G,P,Q,R :Real;
label
_1,_2,_3,_4;
begin
NC := Trunc( N/2+1 );
G := DT/((N*K)*4.0);
for I:=1 to NC do
 begin
  SX[I-1] := 0.0;
  SY[I-1] := 0.0;
  SXY1[I-1] := 0.0;
_1:
  SXY2[I-1] := 0.0;
 end;
for J:=1 to K do
 begin
  JL := Trunc( (J-1)*L );
  for I:=1 to N do
   begin
    IJL := I+JL;
    Z1[I-1] := X[IJL-1];
_2:
    Z2[I-1] := Y[IJL-1];
   end;
  P := 1.0;
  FTF1C(Z1,Z2,N,1,1,P);
  Z1[N+0] := Z1[0];
  Z2[N+0] := Z2[0];
  for I:=1 to NC do
   begin
    IS_ := N+2-I;
    Q := Z1[I-1];
    R := Z1[IS_-1];
    A1 := Q+R;
    B2 := R-Q;
    Q := Z2[I-1];
    R := Z2[IS_-1];
    A2 := Q-R;
    B1 := Q+R;
    A := A1*A1+A2*A2;
    B := B1*B1+B2*B2;
    C := A1*B1+A2*B2;
    D := A1*B2-A2*B1;
    SX[I-1] := SX[I-1]+A;
    SY[I-1] := SY[I-1]+B;
    SXY1[I-1] := SXY1[I-1]+C;
_3:
    SXY2[I-1] := SXY2[I-1]+D;
   end;
 end;
for I:=1 to NC do
 begin
  SX[I-1] := SX[I-1]*G;
  SY[I-1] := SY[I-1]*G;
  SXY1[I-1] := SXY1[I-1]*G;
_4:
  SXY2[I-1] := SXY2[I-1]*G;
 end;
end;

end.
